; ##############################################################################
; ##############################################################################
; ##############################################################################
.macro MACRO_WAIT_1us
	nop		; 1
	nop		; 2
	nop		; 3
	nop		; 4
	nop		; 5
	nop		; 6
	nop		; 7
	nop		; 8
	nop		; 9
	nop		;10
	nop		;11
	nop		;12
	nop		;13
	nop		;14
	nop		;15
	nop		;16
	nop		;17
	nop		;18
	nop		;19
	nop		;20
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
.macro MACRO_REGISTER_WIEDER_HERSTELLEN
	OUT	SREG ,SREG_KOPIE		
	mov TEMP ,temp_KOPIE
	MOVW ZL,ZL_KOPIE 	; Copy Register Word
	MOVW YL,YL_KOPIE 	; Copy Register Word
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
.macro MACRO_VGA_ZEILE_DATA_10
	rjmp VGA_ZEILE_DATA		; 1
	rjmp VGA_ZEILE_DATA		; 2
	rjmp VGA_ZEILE_DATA		; 3
	rjmp VGA_ZEILE_DATA		; 4
	rjmp VGA_ZEILE_DATA		; 5
	rjmp VGA_ZEILE_DATA		; 6
	rjmp VGA_ZEILE_DATA		; 7
	rjmp VGA_ZEILE_DATA		; 8
	rjmp VGA_ZEILE_DATA		; 9
	rjmp VGA_ZEILE_DATA		; 10
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
.macro MACRO_VGA_ZEILE_DATA_100
	MACRO_VGA_ZEILE_DATA_10; 1
	MACRO_VGA_ZEILE_DATA_10; 2
	MACRO_VGA_ZEILE_DATA_10; 3
	MACRO_VGA_ZEILE_DATA_10; 4
	MACRO_VGA_ZEILE_DATA_10; 5
	MACRO_VGA_ZEILE_DATA_10; 6
	MACRO_VGA_ZEILE_DATA_10; 7
	MACRO_VGA_ZEILE_DATA_10; 8
	MACRO_VGA_ZEILE_DATA_10; 9
	MACRO_VGA_ZEILE_DATA_10; 10
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
.macro MACRO_VGA_ZEILE_DATA_480
	MACRO_VGA_ZEILE_DATA_100
	MACRO_VGA_ZEILE_DATA_100
	MACRO_VGA_ZEILE_DATA_100
	MACRO_VGA_ZEILE_DATA_100
	MACRO_VGA_ZEILE_DATA_10
	MACRO_VGA_ZEILE_DATA_10
	MACRO_VGA_ZEILE_DATA_10
	MACRO_VGA_ZEILE_DATA_10
	MACRO_VGA_ZEILE_DATA_10
	MACRO_VGA_ZEILE_DATA_10
	MACRO_VGA_ZEILE_DATA_10
	MACRO_VGA_ZEILE_DATA_10
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
; HSYNC 3,8us																	
.macro MACRO_VGA_HSYNC_IMPULS
	MACRO_WAIT_1us
	nop		; 1
	nop		; 2
	nop		; 3
;-------------------------------------------------------------------------------
; TURBO-WERTE auf Plausibilitt prfen (aktive Zeile)							
	ldi ZL,LOW (adr_VGA_TURBO_BEREICH120)	; TURBO-BEREICH	
	ldi ZH,HIGH(adr_VGA_TURBO_BEREICH120)
	LDS temp,(adr_VGA_BILD_ZEILE)		; BILD-ZEILE	
	add ZL,temp
	adc ZH,NULL
	LD temp,Z							; auslesen		
	cpi temp,82+1 						; vergleich		
	brsh MACRO_VGA_HSYNC_IMPULS_ERROR1
	rjmp MACRO_VGA_HSYNC_IMPULS_OK1		; TAKT-AUSGLEICH
MACRO_VGA_HSYNC_IMPULS_ERROR1:			; ERROR			
	ST Z,NULL							; NULL			
MACRO_VGA_HSYNC_IMPULS_OK1:
;-------------------------------------------------------------------------------
; TURBO-WERTE auf Plausibilitt prfen (aktive Zeile+1)							
	adiw ZL,1							; BILD-ZEILE+1	
	LD temp,Z							; auslesen		
	cpi temp,82+1  						; vergleich		
	brsh MACRO_VGA_HSYNC_IMPULS_ERROR2
	rjmp MACRO_VGA_HSYNC_IMPULS_OK2		; TAKT-AUSGLEICH
MACRO_VGA_HSYNC_IMPULS_ERROR2:			; ERROR			
	ST Z,NULL							; NULL			
MACRO_VGA_HSYNC_IMPULS_OK2:
;-------------------------------------------------------------------------------
; INITIALISIERUNG Y, Z, temp													
	; (Y)=ZEIGER DATA									
	LDS YL,(adr_VGA_ZEIGER_DATA_L)
	LDS YH,(adr_VGA_ZEIGER_DATA_H)
	; (Y) prophylaktisch auf nchste DATENZEILE springen
	subi YL, LOW (-82)				; +82
	sbci YH, HIGH(-82)
	; (Z) auf TURBO_BEREICH 							
	ldi ZL,LOW (adr_VGA_TURBO_BEREICH120)
	ldi ZH,HIGH(adr_VGA_TURBO_BEREICH120)
	; PIXEL-ZEILEN-COUNTER								
	LDS temp,(adr_VGA_PIXEL_ZEILEN_COUNTER)
	dec temp
	; HSYNC												
	sbi (HSYNC_PORT),(HSYNC_PIN_NR)
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 2 RGB-PIXEL ausgeben															
.macro MACRO_VGA_DATA_2_PIXEL
	;------------------
	LD temp,Y+		; 1
	out PORTB,temp
	;------------------
	SWAP temp		; 2
	nop
	out PORTB,temp
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 10 RGB-PIXEL ausgeben															
.macro MACRO_VGA_DATA_PIXEL_10
	MACRO_VGA_DATA_2_PIXEL
	MACRO_VGA_DATA_2_PIXEL
	MACRO_VGA_DATA_2_PIXEL
	MACRO_VGA_DATA_2_PIXEL
	MACRO_VGA_DATA_2_PIXEL
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
.macro MACRO_TURBO
	LD temp,-Z
	tst temp
	breq PC+3
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
